#include "../paraclass.h"

#define DRV_READ_IO_8 'r'
#define DRV_WRITE_IO_8 'w'
#define DRV_READ_IO_16 'r16'
#define DRV_WRITE_IO_16 'w16'

typedef struct Parallel
{
	unsigned short Port;
	unsigned char Data;
	unsigned short Data16;
} Parallel;


unsigned char ParPort::In(unsigned short port)
{
	Parallel temp;
	
	temp.Port = port;

	ioctl(fd, DRV_READ_IO_8, &temp, 0);
	
	return (temp.Data);
}

unsigned short ParPort::In16(unsigned short port)
{
	Parallel temp;
	
	temp.Port = port;
	
	ioctl(fd, DRV_READ_IO_16, &temp, 0);
	
	return (temp.Data16);
}



void ParPort::Out(unsigned short port, unsigned char byte)
{
	Parallel temp;
	
	temp.Port = port;
    temp.Data = byte;

	ioctl(fd, DRV_WRITE_IO_8, &temp, 0);
	
	return;
}

void ParPort::Out16(unsigned short port, unsigned short word)
{
	Parallel temp;
	
	temp.Port = port;
	temp.Data16 = word;
	
	ioctl(fd, DRV_WRITE_IO_16, &temp, 0);
	
	return;
}

void ParPort::OpenPort()
{
fd = open("/dev/misc/parnew", O_RDWR | O_NONBLOCK);
}

void ParPort::ClosePort()
{
close(fd);
}
